class MinMaxInt {

  int v = 0;
  int vMin = 0;
  int vMax = 0;
  String label = "";

  MinMaxInt() {}

  MinMaxInt(int pV, int pVMin, int pVMax, String pLabel) {
    v = pV;
    vMin = pVMin;
    vMax = pVMax;
    label = pLabel;
  }

};


class Cellv4 {

  PVector posVector;
  MinMaxInt v1,v2,v3,v4;

  Satellite satelliteListV1[];
  Satellite satelliteListV2[];
  Satellite satelliteListV3[];
  Satellite satelliteListV4[];

  Cellv4(MinMaxInt pV1, MinMaxInt pV2, MinMaxInt pV3, MinMaxInt pV4) {
    
    v1 = pV1;
    v2 = pV2;
    v3 = pV3;
    v4 = pV4;

    satelliteListV1 = new Satellite[int(v1.v/satellitesFactor)];
    satelliteListV2 = new Satellite[int(v2.v/satellitesFactor)];
    satelliteListV3 = new Satellite[int(v3.v/satellitesFactor)];
    satelliteListV4 = new Satellite[int(v4.v/satellitesFactor)];

    for (int n=0; n<satelliteListV1.length; n++) {satelliteListV1[n] = new Satellite();}
    for (int n=0; n<satelliteListV2.length; n++) {satelliteListV2[n] = new Satellite();}
    for (int n=0; n<satelliteListV3.length; n++) {satelliteListV3[n] = new Satellite();}
    for (int n=0; n<satelliteListV4.length; n++) {satelliteListV4[n] = new Satellite();}

    posVector = new PVector(0,0,0);

  }

  void draw() {

    pushMatrix();

      float x = posVector.x;
      float y = posVector.y;
      float z = posVector.z;

      // Grid
      stroke(labelColor);
      noFill();
      strokeWeight(1);
      line(x,y,0,0,y,0);
      line(x,y,0,x,0,0);
      if(zLinesOn) {line(x,y,z,x,y,0);}
      
      translate(x,y,z);
      
      for (int n=0; n<satelliteListV1.length; n++) {
        int c = int(map(float(v1.v),float(v1.vMin),float(v1.vMax),gradientMin,gradientMax));
        satelliteListV1[n].draw(x,y,z,satellitesFactor + " x " + v1.label,c);
      }

      for (int n=0; n<satelliteListV2.length; n++) {
        int c = int(map(float(v2.v),float(v2.vMin),float(v2.vMax),gradientMin,gradientMax));
        satelliteListV2[n].draw(x,y,z,satellitesFactor + " x " + v2.label,c);
      }

      for (int n=0; n<satelliteListV3.length; n++) {
        int c = int(map(float(v3.v),float(v3.vMin),float(v3.vMax),gradientMin,gradientMax));
        satelliteListV3[n].draw(x,y,z,satellitesFactor + " x " + v3.label,c);
      }

      for (int n=0; n<satelliteListV4.length; n++) {
        int c = int(map(float(v4.v),float(v4.vMin),float(v4.vMax),gradientMin,gradientMax));
        satelliteListV4[n].draw(x,y,z,satellitesFactor + " x " + v4.label,c);
      }

    popMatrix();

  }

  void updateV1(int newV) {v1.v = newV;}
  void updateV2(int newV) {v2.v = newV;}
  void updateV3(int newV) {v3.v = newV;}
  void updateV4(int newV) {v4.v = newV;}
  void updatePos(PVector newPos) {posVector = newPos;}

};


class Satellite {

    float d,z,a,g;
    float originX,originY,originZ;
    String shadowText;
    int colorGradient;
    int sSign;

    Satellite() {

      if (random(1) > 0.5) {sSign = 1;}
      else {sSign = -1;}
      
      d = random(distMin,distMax);
      z = random(-zOffset,zOffset);
      a = random(360);
      g = random(sizeMin,sizeMax);

    }

    void draw(float pX,float pY,float pZ, String pShadowText, int pColorGradient) {

      originX = pX;
      originY = pY;
      originZ = pZ;
      shadowText = pShadowText;
      colorGradient = pColorGradient;

      float s = sSign * map(colorGradient,0,255,0,5);

      if(!rotationOn) {s = 0;}
      a += s;
      if (a>360) {a=0;}
      if (a<0) {a=360;}

      pushMatrix();

        int lineColor = int((255-colorGradient)*1.7);
        colorMode(HSB);
        stroke(lineHue,100,lineColor);
        noFill();
        strokeWeight(0.4);
        line(sin(radians(a))*d,cos(radians(a))*d,z,0,0,0);
        colorMode(RGB);

        fill(lineColor);
        textSize(3);
        text(shadowText,sin(radians(a))*d,cos(radians(a))*d,-originZ);
        
        colorMode(RGB);
        int boxColor = 255-colorGradient;
        stroke(boxColor,boxColor,boxColor);
        noFill();
        strokeWeight(1);

        translate(sin(radians(a))*d,cos(radians(a))*d,z);
        rotate(radians(360-a));

        // box(g,g,g);
        sphere(g);

      popMatrix();

    }

  }